"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

exports.__esModule = true;
exports.SVGOverlay = exports.useSVGOverlay = exports.useSVGOverlayElement = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/objectWithoutPropertiesLoose"));

var _core = require("@react-leaflet/core");

var _leaflet = require("leaflet");

var _react = require("react");

var _reactDom = require("react-dom");

var useSVGOverlayElement = (0, _core.createElementHook)(function createSVGOverlay(props, context) {
  var bounds = props.bounds,
      options = (0, _objectWithoutPropertiesLoose2.default)(props, ["bounds"]);
  var container = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
  var instance = new _leaflet.SVGOverlay(container, bounds, options);
  return {
    instance: instance,
    container: container,
    context: context
  };
}, _core.updateMediaOverlay);
exports.useSVGOverlayElement = useSVGOverlayElement;
var useSVGOverlay = (0, _core.createLayerHook)(useSVGOverlayElement);
exports.useSVGOverlay = useSVGOverlay;

function SVGOverlayComponent(_ref, ref) {
  var children = _ref.children,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["children"]);
  var _useSVGOverlay$curren = useSVGOverlay(options).current,
      instance = _useSVGOverlay$curren.instance,
      container = _useSVGOverlay$curren.container;
  (0, _react.useImperativeHandle)(ref, function () {
    return instance;
  });
  return container == null || children == null ? null : (0, _reactDom.createPortal)(children, container);
}

var SVGOverlay = (0, _react.forwardRef)(SVGOverlayComponent);
exports.SVGOverlay = SVGOverlay;