import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import { createOverlayComponent } from '@react-leaflet/core';
import { Popup as LeafletPopup } from 'leaflet';
import { useEffect } from 'react';
export var Popup = createOverlayComponent(function createPopup(props, context) {
  return {
    instance: new LeafletPopup(props, context.overlayContainer),
    context: context
  };
}, function usePopupLifecycle(element, context, props, setOpen) {
  useEffect(function addPopup() {
    var instance = element.instance;

    function onPopupOpen(event) {
      if (event.popup === instance) {
        instance.update();
        setOpen(true);
        props.onOpen == null ? void 0 : props.onOpen();
      }
    }

    function onPopupClose(event) {
      if (event.popup === instance) {
        setOpen(false);
        props.onClose == null ? void 0 : props.onClose();
      }
    }

    _mapInstanceProperty(context).on({
      // @ts-ignore emits PopupEvent instead of LeafletEvent
      popupopen: onPopupOpen,
      // @ts-ignore emits PopupEvent instead of LeafletEvent
      popupclose: onPopupClose
    });

    if (context.overlayContainer == null) {
      // Attach to a Map
      if (props.position != null) {
        instance.setLatLng(props.position);
      }

      instance.openOn(_mapInstanceProperty(context));
    } else {
      // Attach to container component
      context.overlayContainer.bindPopup(instance);
    }

    return function removePopup() {
      _mapInstanceProperty(context).off({
        // @ts-ignore emits PopupEvent instead of LeafletEvent
        popupopen: onPopupOpen,
        // @ts-ignore emits PopupEvent instead of LeafletEvent
        popupclose: onPopupClose
      });

      if (context.overlayContainer == null) {
        _mapInstanceProperty(context).removeLayer(instance);
      } else {
        context.overlayContainer.unbindPopup();
      }
    };
  }, [element, context, props, setOpen]);
});