import _objectWithoutPropertiesLoose from "@babel/runtime-corejs3/helpers/esm/objectWithoutPropertiesLoose";
import { createElementHook, createLayerHook, updateMediaOverlay } from '@react-leaflet/core';
import { SVGOverlay as LeafletSVGOverlay } from 'leaflet';
import { forwardRef, useImperativeHandle } from 'react';
import { createPortal } from 'react-dom';
export var useSVGOverlayElement = createElementHook(function createSVGOverlay(props, context) {
  var bounds = props.bounds,
      options = _objectWithoutPropertiesLoose(props, ["bounds"]);

  var container = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
  var instance = new LeafletSVGOverlay(container, bounds, options);
  return {
    instance: instance,
    container: container,
    context: context
  };
}, updateMediaOverlay);
export var useSVGOverlay = createLayerHook(useSVGOverlayElement);

function SVGOverlayComponent(_ref, ref) {
  var children = _ref.children,
      options = _objectWithoutPropertiesLoose(_ref, ["children"]);

  var _useSVGOverlay$curren = useSVGOverlay(options).current,
      instance = _useSVGOverlay$curren.instance,
      container = _useSVGOverlay$curren.container;
  useImperativeHandle(ref, function () {
    return instance;
  });
  return container == null || children == null ? null : createPortal(children, container);
}

export var SVGOverlay = forwardRef(SVGOverlayComponent);